﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace xmlreader_1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ReadXML();
        }

        /// <summary>
        /// XML 파일 읽기
        /// </summary>
        private void ReadXML()
        {
            FileStream fStream = new FileStream("books.xml", FileMode.Open);
            System.Text.Encoding enc = System.Text.Encoding.Default;
            XmlParserContext context = new XmlParserContext(null, null, null, XmlSpace.Default, enc);
            XmlTextReader textReader = new XmlTextReader(fStream, XmlNodeType.Element, context);

            string tagname = "";
            while (textReader.Read())
            {
                switch (textReader.NodeType)
                {
                    case XmlNodeType.Element:
                        //rBox.Text += textReader.Name.ToString() + "  \r\n";
                        tagname = textReader.Name;
                        break;
                    case XmlNodeType.Text:
                        if (tagname.Equals("date"))
                        {
                            rBox.AppendText(string.Concat(textReader.Value.ToString(),"  \r\n"), Color.Red);
                        }
                        if (tagname.Equals("title"))
                        {
                            rBox.AppendText(string.Concat("내역: ", textReader.Value.ToString(), "  \r\n"), Color.Blue);
                        }
                        if (tagname.Equals("note"))
                        {
                            rBox.AppendText(string.Concat("상세내역: ", textReader.Value.ToString(), "  \r\n\r\n"), Color.Green);
                        }
                        break;
                    case XmlNodeType.EndElement:
                        //rBox.Text += textReader.Name.ToString() + "  \r\n";
                        break;
                }
            }
            textReader.Close();
        }
    }

    #region RichTextBoxExtensions
    public static class RichTextBoxExtensions
    {
        public static void AppendText(this RichTextBox box, string text, Color color)
        {
            box.SelectionStart = box.TextLength;
            box.SelectionLength = 0;
            box.SelectionColor = color;
            box.AppendText(text);
            box.SelectionColor = box.ForeColor;
        }

        public static void AppendText(this RichTextBox box, string text, Color color, FontStyle fontstyle)
        {
            box.SelectionStart = box.TextLength;
            box.SelectionLength = 0;
            box.SelectionColor = color;
            box.AppendText(text);
            box.SelectionColor = box.ForeColor;

            Font currentFont = box.SelectionFont;
            FontStyle newFontStyle = fontstyle;
            box.SelectionFont = new Font(currentFont.FontFamily, currentFont.Size, newFontStyle);
        }
    }
    #endregion


}
